package com.cloudcross.ssp.web.operator.main.ap;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.ArrayUtils;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.cloudcross.ssp.base.web.SimpleController;
import com.cloudcross.ssp.common.consts.Status;
import com.cloudcross.ssp.common.utils.Common;
import com.cloudcross.ssp.common.utils.LangUtil;
import com.cloudcross.ssp.common.utils.Pager;
import com.cloudcross.ssp.common.utils.Pager1;
import com.cloudcross.ssp.common.utils.SqlHelper;
import com.cloudcross.ssp.model.Account;
import com.cloudcross.ssp.model.Advertiser;
import com.cloudcross.ssp.model.Log;
import com.cloudcross.ssp.model.Wifi;
import com.cloudcross.ssp.model.WifiGroup;
import com.cloudcross.ssp.model.WifiGroupInfo;
import com.cloudcross.ssp.model.pojo.WifiPojo;
import com.cloudcross.ssp.service.ILogService;
import com.cloudcross.ssp.service.IWifiGroupInfoService;
import com.cloudcross.ssp.service.IWifiGroupService;
import com.cloudcross.ssp.service.IWifiService;
/**
 * 
 *
 * 类名称：ApgroupController
 * 类描述：热点分组
 * 创建人：zhoujun
 * 修改人：zhoujun
 * 修改时间：2015年11月19日 下午12:26:50
 * 修改备注：
 * @version 1.0.0
 *
 */
@Controller
@RequestMapping("/operator/main/ap/apgroup")
public class ApgroupController extends SimpleController{
	private static final Logger LOG = Logger.getLogger(ApgroupController.class);
	
	@Autowired
	private IWifiGroupInfoService wifiGroupInfoService;
	@Autowired
	private IWifiGroupService wifiGroupService;
	@Autowired
	private IWifiService wifiService;
	@Autowired
	private ILogService logService;
	/**
	 * 媒体自用分组list页数据加载
	 * list：(这里用一句话描述这个方法的作用)
	 * (这里描述这个方法适用条件 – 可选)
	 * 创建人：zhoujun
	 * 修改人：zhoujun
	 * @param model
	 * @param paramMap
	 * @param page
	 * @return
	 *String
	 * @exception
	 * @since  1.0.0
	 */
	@RequestMapping("/list")
	public String list(Model model,@RequestParam Map<String,Object>paramMap,@RequestParam(defaultValue="1")int page){
		//通过登录账号得到当前登录的运营商id
		Account account = getLoginUser();
		paramMap.put("operatorId", account.getOperatorId());
		
		Pager pager = new Pager();
		//查询符合条件的总的条数
		int totalRow = wifiService.countWifiGroupByCondition(paramMap);
		pager.setPage(page);
		pager.setTotalRow(totalRow);
		List<WifiPojo> wifiList = wifiService.queryWifiGroupByCondition(paramMap, pager);
		model.addAttribute("pager",pager);
		model.addAttribute("wifiList", wifiList);
		return page("list");
	}
	
	/**！！！！！！！！！！！！！！create页面的所有数据加载都用这个方法
	 * 到创建分组页
	 * create：(这里用一句话描述这个方法的作用)
	 * (这里描述这个方法适用条件 – 可选)
	 * 创建人：zhoujun
	 * 修改人：zhoujun
	 * @param model
	 * @param name  分组名
	 * @param apmac mac地址
	 * @return
	 *String
	 * @exception
	 * @since  1.0.0
	 */
	@RequestMapping("/create")
	public String create(Model model,String groupId,String name,String apmac,
			@RequestParam(defaultValue = "1") int page,
			@RequestParam(defaultValue = "1") int page1){
		//分页显示所有的分组名(30一页)
		Map<String,Object> condition = new HashMap<String,Object>();
		condition.put("operatorId", getLoginUser().getOperatorId());
		int countGroupName = this.wifiGroupInfoService.queryWifiGroupInfoCountByCondition(condition);
		Pager1 pager1 = new Pager1();
		pager1.setPage(page1);
		pager1.setTotalRow(countGroupName);
		List<WifiGroupInfo> listGroupName = this.wifiGroupInfoService.queryWifiGroupInfoByCondition(condition, pager1);
		
		//分页显示热点
		Pager pager = new Pager();
		Integer wificount = 0;
		List<Wifi> wifiList = null;
		
		//首次进入页面时，name和apmac没有值
		if(null == name || "".equals(name)){
			pager.setPage(page);
			pager.setTotalRow(10);
			wifiList = new ArrayList<Wifi>();
		}else{
			Long operatorId = getLoginUser().getOperatorId();
			Map<String,Object> map = new HashMap<String,Object>();
			map.put("operatorId", operatorId);
			//按分组名查询热点分页显示
			map.put("name", name);
			//apmac一定是某个分组下的热点的apmac
			//apmac为空表示点击分组名查询热点，apmac不为空表示在分组下根据apmac查询
			if(null !=apmac && !"".equals(apmac)){
				map.put("apmac", apmac);
			}
			wificount = wifiService.queryWifiCountByCondition(map);
			pager.setPage(page);
			pager.setTotalRow(wificount);
			map.put("pager", pager);
			wifiList = wifiService.queryWifiByCondition(map,pager);
		}
		model.addAttribute("groupId",groupId);
		model.addAttribute("name",name);
		model.addAttribute("apmac",apmac);
		model.addAttribute("pager",pager);
		model.addAttribute("listGroupName", listGroupName);
		model.addAttribute("pager1",pager1);
		model.addAttribute("wifiList",wifiList);
		model.addAttribute("operatorId", getLoginUser().getOperatorId());
		return page("create");
	}
	
	/**
	 * 点击分组，看到分组详情
	 * queryWifiByCondition：(这里用一句话描述这个方法的作用)
	 * (这里描述这个方法适用条件 – 可选)
	 * 创建人：zhoujun
	 * 修改人：zhoujun
	 * @param page
	 * @param apgroupId
	 * @param apmac
	 * @return
	 *List<WifiPojo>
	 * @exception
	 * @since  1.0.0
	 */
	/*@RequestMapping("/wifidetail")
	public List<WifiPojo> queryWifiByCondition(@RequestParam(defaultValue="1")int page,String apgroupId,String apmac){
		List<WifiPojo> wifiList = null;
		Map<String,Object>condition = new HashMap<String,Object>();
		if(null != apgroupId && !"".equals(apgroupId) ){
			condition.put("apgroupId", apgroupId);
		}
		if(null != apmac && !"".equals(apmac)){
			condition.put("apmac", apmac);
		}
		Pager pager = new Pager();
		int totalRow = wifiService.queryWifiCountByCondition(condition);
		pager.setPage(page);
		pager.setTotalRow(totalRow);
		wifiList = null;//wifiService.queryWifiByCondition(condition,pager);
		return wifiList;
	}*/
	
	/**
	 *创建分组页添加分组
	 * addGroupName：(这里用一句话描述这个方法的作用)
	 * (这里描述这个方法适用条件 – 可选)
	 * 创建人：zhoujun
	 * 修改人：zhoujun
	 * @param name
	 * @return
	 *String
	 * @exception
	 * @since  1.0.0
	 */
	@RequestMapping("/addGroupName")
	@ResponseBody
	public String  addGroupName(String name){
		WifiGroupInfo wifiGroupInfo = new WifiGroupInfo();
		wifiGroupInfo.setName(name);
		wifiGroupInfo.setStatus(0);//开启
		wifiGroupInfo.setUpdated(new Date());
		wifiGroupInfo.setOperatorId(getLoginUser().getOperatorId());
		this.wifiGroupInfoService.add(wifiGroupInfo);
		return "添加成功";
	}
	
	/**
	 * 判断分组名是否存在，存在返回true,不存在返回false
	 * @param name
	 * @return
	 */
	@RequestMapping("/isExist")
	@ResponseBody
	public Boolean isGroupNameExist(String name){
		Boolean flag = false;
		Map<String,Object>condition = new HashMap<String,Object>();
		condition.put("name",name);
		condition.put("operatorId", getLoginUser().getOperatorId());
		List<WifiGroupInfo> list = this.wifiGroupInfoService.queryWifiGroupInfoByCondition(condition);
		if(list != null && list.size() > 0){
			flag = true;//名称已存在
		}
		return flag;
	}
	/**
	 * 分组页查询所有分组名
	 * queryWifiGroupInfoNames：(这里用一句话描述这个方法的作用)
	 * (这里描述这个方法适用条件 – 可选)
	 * 创建人：zhoujun
	 * 修改人：zhoujun
	 * @param model
	 *void
	 * @exception
	 * @since  1.0.0
	 */
	/*@RequestMapping("/queryGroupName")
	@ResponseBody
	public String queryWifiGroupInfoNames(Model model,@RequestParam(defaultValue = "1") int page){
		Map<String,Object> condition = new HashMap<String,Object>();
		condition.put("operatorId", getLoginUser().getOperatorId());
		List<WifiGroupInfo> listGroupName = this.wifiGroupInfoService.findByParams(condition, null);
		model.addAttribute("listGroupName", listGroupName);
		Pager1 pager1 = new Pager1();
		pager1.setPage(page);
		pager1.setTotalRow(30);
		model.addAttribute("pager",pager1);
		return page("create");
	}*/
	
	@RequestMapping("/edit")
	public String list(Model model, @RequestParam HashMap<String, Object> paramMap,
			@RequestParam(defaultValue = "1") int page) {
		
		//通过登录账号得到当前登录的运营商id
		Account account = getLoginUser();
		paramMap.put("operatorId", account.getOperatorId());
		
		String cn = null;
		String cnCity = null;
		/**
		 * 下面对传递过来的几个参数进行处理
		 */
		if(null != paramMap.get("cn") && !"".equals(paramMap.get("cn"))) {
			cn = String.valueOf(paramMap.get("cn"));
		} 
		
		if(null != paramMap.get("cnCity") && !"".equals(paramMap.get("cnCity"))) {
			cnCity = String.valueOf(paramMap.get("cnCity"));
		}
		paramMap.put("cn", cn);
		paramMap.put("cnCity", cnCity);
		
		//按热点名称和详细地址搜索
		String apmac = "";
		if(null != paramMap.get("searchValue") && !"".equals(paramMap.get("searchValue"))) {
				apmac = (String) paramMap.get("searchValue");
				paramMap.put("apmac", apmac);
		} else {
			paramMap.put("searchValue", null);
		}
		
		int totalRow = 0;
		Pager pager = null;
		pager = new Pager();
		//查询符合条件的总的条数
		totalRow = wifiService.findWifiCountByCondition(paramMap);
		pager.setPage(page);
		pager.setTotalRow(totalRow);
		List<Wifi> wifiList = wifiService.findWifiByCondition(paramMap, pager);
		//分组名
		Map<String,Object>map = new HashMap<String,Object>();
		map.put("operatorId", getLoginUser().getOperatorId());
		List<WifiGroupInfo> listGroupName = this.wifiGroupInfoService.queryGroupNameAll(map);
		//如果下拉框传的是默认值，则回传一个对应的值给前端
		if(null == cn) {
			cn = "省";
		}
		
		if(null == cnCity) {
			cnCity = "市";
		}
		paramMap.put("cn", cn);
		paramMap.put("cnCity", cnCity);
		paramMap.put("searchValue", apmac);
		model.addAttribute("pager",pager);
		model.addAllAttributes(paramMap);
		model.addAttribute("wifiList", wifiList);
		model.addAttribute("listGroupName", listGroupName);
		return page("edit");
	}
	
	/**
	 * 想分组里添加热点
	 * addWifiGroup：(这里用一句话描述这个方法的作用)
	 * (这里描述这个方法适用条件 – 可选)
	 * 创建人：zhoujun
	 * 修改人：zhoujun
	 * @param model
	 * @param wifiId
	 * @param groupId
	 * @return
	 *String
	 * @exception
	 * @since  1.0.0
	 */
	/*@RequestMapping("/addWifiGroup")
	@ResponseBody
	public String addWifiGroup(Model model,long wifiId,long groupId){
		Boolean flag = false;
		String result = "";
		WifiGroup wifiGroup = new WifiGroup();
		wifiGroup.setGroupId(groupId);
		wifiGroup.setWifiId(wifiId);
		wifiGroup.setStatus(0);
		wifiGroup.setSupdated(new Date().getTime()/1000);
		flag = this.wifiGroupService.add(wifiGroup);
		if(flag){
			result = "成功";
		}else{
			result = "失败";
		}
		return result;	
	}
	*/
	/**
	 * 根据wifiID将热点移除分组
	 * @param id wifi的id
	 * @param request
	 * @return
	 */
	@RequestMapping("/removeWifiFromGroupByWifiId")
	@ResponseBody
	public String removeWifiFromGroupByWifiId(Long[] id,HttpServletRequest request) {
		if (ArrayUtils.isNotEmpty(id)) {
			//循环得到订单名称（批量或者单个都可以）_________为了插入log记录的时候显示订单名称！
			List<String> list = new ArrayList<String>();
			
			for (int i = 0;i < id.length;i++) {
				String wifiName = this.wifiService.queryWifiNameById(id[i]);
				list.add(wifiName);
			}
			
			if(wifiGroupService.updateStatus(LangUtil.array2List(id),Status.delete.value) ) {
				//如果删除订单成功，向log数据库中插入记录！
				for (int i = 0;i < id.length;i++) {
				Log logDel= new Log();
				logDel.setModule("Operator");//对应模块
				logDel.setTableName("t_wifi_group");//对应的表名
				logDel.setRecordId(id[i]);//对应广告主id
				logDel.setActionType("删除");	//操作类型
				logDel.setAction("将"+list.get(i)+"热点移除分组");//变更详情
				//下面这几个字段目前后端数据没有得到。所以仅作测试用！
				logDel.setActionTime("100");
				logDel.setAccountId(Long.valueOf(getLoginUser().getId()));
				logDel.setUserIp(Common.toIpAddr(request));
				logDel.setAccountName(getLoginUser().getAccountName());
				logService.add(logDel);
				}
				
			}
		}
		return OK;
	}
	/**
	 * 根据分组ID移除：1.移除分组中的所有wifi，2.移除分组
	 * @param id  wifi_group_info.id 
	 * @param request
	 * @return
	 */
	@RequestMapping("/removeWifiFromGroupByGroupId")
	@ResponseBody
	public String removeWifiFromGroupByGroupName(Long id,HttpServletRequest request) {
		if (null != id && !"".equals(id) && id>0) {
			if(wifiGroupService.updateStatusById(id,Status.delete.value) ) {
				if(wifiGroupInfoService.updateStatusById(id, Status.delete.value)){
					Log log = new Log();
					log.setModule("Operator");//对应模块
					log.setTableName("t_wifi_group_info");//对应的表名
					log.setRecordId(id);//
					log.setActionType("删除");	//操作类型
					log.setAction("将ID="+id+"分组删除除");//变更详情
					//下面这几个字段目前后端数据没有得到。所以仅作测试用！
					log.setActionTime("100");
					log.setAccountId(Long.valueOf(getLoginUser().getId()));
					log.setUserIp(Common.toIpAddr(request));
					log.setAccountName(getLoginUser().getAccountName());
					logService.add(log);
				}
				
				Log logDel= new Log();
				logDel.setModule("Operator");//对应模块
				logDel.setTableName("t_wifi_group");//对应的表名
				logDel.setRecordId(id);//
				logDel.setActionType("删除");	//操作类型
				logDel.setAction("将ID="+id+"分组的热点移除");//变更详情
				//下面这几个字段目前后端数据没有得到。所以仅作测试用！
				logDel.setActionTime("100");
				logDel.setAccountId(Long.valueOf(getLoginUser().getId()));
				logDel.setUserIp(Common.toIpAddr(request));
				logDel.setAccountName(getLoginUser().getAccountName());
				logService.add(logDel);
			}
		}
		return OK;
	}
	
	/**
	 * edit页面保存
	 * @param id wifi的ID，数组形式
	 * @param wifiGroupInfoId 分组ID
	 * @param request
	 * @return
	 */
	@RequestMapping("save")
	@ResponseBody
	public String addWifiToGroup(Long[]id,Long wifiGroupInfoId,HttpServletRequest request) {
		WifiGroup wifiGroup = new WifiGroup();
		wifiGroup.setGroupId(wifiGroupInfoId);
		wifiGroup.setStatus(0);
		wifiGroup.setSupdated(new Date().getTime()/1000);
		//查询分组里的wifi
		List<Long> wifiIdList = this.wifiGroupService.queryWifiIdByGroupId(wifiGroupInfoId);
		List<Long> idList = LangUtil.array2List(id);
		if(wifiIdList != null && wifiIdList.size()>0){
			int len = wifiIdList.size(); 
			for(int i=0;i<len;i++){
				idList.remove(wifiIdList.get(i));
			}
		}
		boolean flag = this.wifiGroupService.addWifiToGroup(idList,wifiGroup);
		if(flag){
			for(int i=0;i<id.length;i++){
				Log log = new Log();
				log.setModule("Operator");//对应模块
				log.setTableName("t_wifi_group");//对应的表名
				log.setRecordId(wifiGroupInfoId);//
				log.setActionType("添加");	//操作类型
				log.setAction("将ID="+id[i]+"的wifi添加到ID="+wifiGroupInfoId+"的分组");//变更详情
				//下面这几个字段目前后端数据没有得到。所以仅作测试用！
				log.setActionTime("100");
				log.setAccountId(Long.valueOf(getLoginUser().getId()));
				log.setUserIp(Common.toIpAddr(request));
				log.setAccountName(getLoginUser().getAccountName());
				logService.add(log);
			}
			
		}
		return OK;
	}
	
}
